<?php
namespace FiloBlu\ExtViSualMerchandiser\Ui\Component\Listing\Column;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Catalog\Api\ProductAttributeRepositoryInterface as AttributeRepository;
class Color extends \Magento\Ui\Component\Listing\Columns\Column
{

    protected $_eavEntityAttribute;
    protected $attributeRepository;

    protected $collection;

    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        AttributeRepository $attributeRepository,

        \Magento\Eav\Model\ResourceModel\Entity\Attribute $eavEntityAttribute,
        \Magento\Catalog\Model\ResourceModel\Product\Collection $collection,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->_eavEntityAttribute = $eavEntityAttribute;
        $this->collection = $collection;
        $this->attributeRepository = $attributeRepository;
    }


    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            $attributes = $this->attributeRepository->get('color');
            $fieldName = $this->getData('name');
            $product = $this->collection->load()->addAttributeToSelect('color');

            foreach ($dataSource['data']['items'] as & $item) {
                $attrStrings = [];
                foreach ($attributes as $attributeCode => $attribute) {
                    $item['color'] = $product->addAttributeToFilter('color');
                    if (isset($item[$attributeCode])) {
                        $attrStrings[] = $attribute['color'] . ': ' . $attribute['options'][$item[$attributeCode]];
                    }
                    $item[$fieldName] = implode(', ', $attrStrings);
                }
            }
        }
       return $dataSource;


//        if (isset($dataSource['data']['items'])) {
//            foreach ($dataSource ['data']['items'] as  & $item)
//            {
//                //$item['color'] = $this->_eavEntityAttribute->getIdByCode('catalog_product', 'color');
//                $products = $this->collection->load()->addAttributeToSelect('color');
//                foreach ($products as $product) {
//
//                    $item['color'] = $product->getValue($item);
//
//                   // $product->getAttributes('color');
//                }
//
//
//                $dataSource;
//
//            }
//        return $dataSource;
      }
    public function toOptionArray()
    {
        return $this->_eavEntityAttribute->getAttributeCodesByFrontendType('color');
    }
}

